package com.xpo.ltl.api.client.exception;

import java.io.Serializable;

public class ServiceException extends Exception implements Serializable
{

    private final static long serialVersionUID = 1L;
    protected FaultResponse fault;

	public ServiceException() {
	}

	public ServiceException(FaultResponse fault) {
		super(fault.getMessage());
		this.fault = fault;
	}

	public ServiceException(String errorCode, String message) {
		super(message);
		fault = new FaultResponse();
		fault.setErrorCode(errorCode);
		fault.setMessage(message);
	}

    /**
     * Gets the value of the fault property.
     * 
     * @return
     *     possible object is
     *     {@link FaultResponse }
     *     
     */
    public FaultResponse getFault() {
        return fault;
    }

    /**
     * Sets the value of the fault property.
     * 
     * @param value
     *     allowed object is
     *     {@link FaultResponse }
     *     
     */
    public void setFault(FaultResponse value) {
        this.fault = value;
    }

}
