package com.xpo.ltl.api.client.util;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;

import org.apache.commons.lang3.time.DateUtils;

public class DateTimeHelper {
	
	private static final Pattern TZ_COLON_FORMAT = Pattern.compile("(.*)\\.[0-9]{1,3}(\\-|\\+)([0-9]{2}):([0-9]{2})|(.*)(\\-|\\+)([0-9]{2}):([0-9]{2})");
	
	public static XMLGregorianCalendar convertCalendarToXMLGC(Calendar calendar) throws DatatypeConfigurationException {
		XMLGregorianCalendar xmlGC = null;
		if(calendar != null){
				xmlGC = DatatypeFactory.newInstance().newXMLGregorianCalendar();
				xmlGC.setYear(calendar.get(Calendar.YEAR));
				xmlGC.setDay(calendar.get(Calendar.DAY_OF_MONTH));
				xmlGC.setMonth(calendar.get(Calendar.MONTH)+ 1);
				xmlGC.setHour(calendar.get(Calendar.HOUR_OF_DAY));
				xmlGC.setMinute(calendar.get(Calendar.MINUTE));
				xmlGC.setSecond(calendar.get(Calendar.SECOND));
				xmlGC.setMillisecond(calendar.get(Calendar.MILLISECOND)); 
		}
		return xmlGC;
	}

	public static XMLGregorianCalendar convertTimeInMillisToXMLGC(long timeInMillis) throws DatatypeConfigurationException {
		GregorianCalendar gc = new GregorianCalendar();
		gc.setTimeInMillis(timeInMillis);
		XMLGregorianCalendar cal;
		cal = DatatypeFactory.newInstance().newXMLGregorianCalendar(gc);
		return cal;
	}

	public static XMLGregorianCalendar convertStringToXMLGC(String dateTime) throws Exception {
		GregorianCalendar gc = new GregorianCalendar();
		Matcher m = TZ_COLON_FORMAT.matcher(dateTime);
		StringBuffer sb = new StringBuffer();
		if(m.matches()) {
			for(int i=1; i<=m.groupCount(); i++) {
				if(m.group(i) != null) {
					sb.append(m.group(i));
				}
			}
			dateTime = sb.toString();
		}
		Date d = DateUtils.parseDate(dateTime, "yyyy-MM-dd'T'hh:mm:ssZ", "yyyy-MM-dd", "yyyy-MM-dd-hh.mm.ss.SSS");
		gc.setTimeInMillis(d.getTime());
		XMLGregorianCalendar cal;
		cal = DatatypeFactory.newInstance().newXMLGregorianCalendar(gc);
		return cal;
	}
}
